
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class AccountsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const accounts = await db.accounts.create(
            {
                id: data.id || undefined,
        
        code: data.code
        ||
        null
            ,
            
        name: data.name
        ||
        null
            ,
            
        accountType: data.accountType
        ||
        null
            ,
            
        isHeader: data.isHeader
        ||
        false
        
            ,
            
        normalBalance: data.normalBalance
        ||
        null
            ,
            
        isActive: data.isActive
        ||
        false
        
            ,
            
        description: data.description
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await accounts.setParent( data.parent || null, {
            transaction,
        });
        

        

        

        return accounts;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const accountsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                code: item.code
            ||
            null
            ,
            
                name: item.name
            ||
            null
            ,
            
                accountType: item.accountType
            ||
            null
            ,
            
                isHeader: item.isHeader
            ||
            false
        
            ,
            
                normalBalance: item.normalBalance
            ||
            null
            ,
            
                isActive: item.isActive
            ||
            false
        
            ,
            
                description: item.description
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const accounts = await db.accounts.bulkCreate(accountsData, { transaction });

        // For each item created, replace relation files
        

        return accounts;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const accounts = await db.accounts.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.code !== undefined) updatePayload.code = data.code;
        
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.accountType !== undefined) updatePayload.accountType = data.accountType;
        
        
        if (data.isHeader !== undefined) updatePayload.isHeader = data.isHeader;
        
        
        if (data.normalBalance !== undefined) updatePayload.normalBalance = data.normalBalance;
        
        
        if (data.isActive !== undefined) updatePayload.isActive = data.isActive;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        updatePayload.updatedById = currentUser.id;

        await accounts.update(updatePayload, {transaction});

        
        
        if (data.parent !== undefined) {
            await accounts.setParent(
              
              data.parent,
              
              { transaction }
            );
        }
        

        
        

        

        return accounts;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const accounts = await db.accounts.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of accounts) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of accounts) {
                await record.destroy({transaction});
            }
        });


        return accounts;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const accounts = await db.accounts.findByPk(id, options);

        await accounts.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await accounts.destroy({
            transaction
        });

        return accounts;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const accounts = await db.accounts.findOne(
            { where },
            { transaction },
        );

        if (!accounts) {
            return accounts;
        }

        const output = accounts.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.journal_lines_account = await accounts.getJournal_lines_account({
            transaction
        });
        
        
        output.vendors_defaultAccount = await accounts.getVendors_defaultAccount({
            transaction
        });
        
        
        output.ap_invoices_glAccount = await accounts.getAp_invoices_glAccount({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.parent = await accounts.getParent({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.accounts,
        as: 'parent',
        
        where: filter.parent ? {
          [Op.or]: [
            { id: { [Op.in]: filter.parent.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.parent.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'accounts',
                        'code',
                        filter.code,
                    ),
                };
            }
            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'accounts',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'accounts',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.accountType) {
                where = {
                    ...where,
                accountType: filter.accountType,
            };
            }
            
            if (filter.isHeader) {
                where = {
                    ...where,
                isHeader: filter.isHeader,
            };
            }
            
            if (filter.normalBalance) {
                where = {
                    ...where,
                normalBalance: filter.normalBalance,
            };
            }
            
            if (filter.isActive) {
                where = {
                    ...where,
                isActive: filter.isActive,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.accounts.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'accounts',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.accounts.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

